module AdvancedDCL
  module Errbar
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("errbartype", Fixnum, "uusebt", "uuqebt", 1, 1)
      @param.init("errbarindex", Fixnum, "uusebi", "uuqebi", 1, 1)
      @param.init("errbarsize", Float, "uusebs", "uuqebs", 1, 1)
      
      @param.init("variablerange", [2, Float], "variablerange", "variabelrangeget", 3, 3)
      @param.init("uref", Float, "uurset", "uurget", 0, 0)

      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def ydraw(x1, x2, y, temp=nil)
      rundef = Fig.rundef
      if(x1.is_a?(NArray))
	x1max = x1.max.to_f
	x1min = x1.min.to_f
      elsif(x1.is_a?(Array))
	x1max = x1[-1].to_f
	x1min = x1[0].to_f
      end
      if(x2.is_a?(NArray))
	x2max = x2.max.to_f
	x2min = x2.min.to_f
      elsif(x2.is_a?(Array))
	x2max = x2[-1].to_f
	x2min = x2[0].to_f
      end
      if(x1==rundef || x2==rundef)
	x = rundef
      else
	x=Array.new(2)
	if(x1min<x2min)
	  x[0]=x1min
	else
	  x[0]=x2min
	end
	if(x1max>x2max)
	  x[1]=x1max
	else
	  x[1]=x2max
	end
      end
      Basics.checkundef(x, y)

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uherb(x1.length, x1, x2, y)
      @backup.sync
      @temp_param.clear
    end

    def xdraw(x, y1, y2, temp=nil)
      rundef = Fig.rundef
      if(y1.is_a?(NArray))
	y1max = y1.max.to_f
	y1min = y1.min.to_f
      elsif(y1.is_a?(Array))
	y1max = y1[-1].to_f
	y1min = y1[0].to_f
      end
      if(y2.is_a?(NArray))
	y2max = y2.max.to_f
	y2min = y2.min.to_f
      elsif(y2.is_a?(Array))
	y2max = y2[-1].to_f
	y2min = y2[0].to_f
      end
      if(y1==rundef || y2==rundef)
	y = rundef
      else
	y=Array.new(2)
	if(y1min<y2min)
	  y[0]=y1min
	else
	  y[0]=y2min
	end
	if(y1max>y2max)
	  y[1]=y1max
	else
	  y[1]=y2max
	end
      end
      Basics.checkundef(x, y)

      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.uverb(x.length, x, y1, y2)
      
      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :xdraw
    module_function :ydraw
    
    param_init
    
#----------------------------------------------------------
    
    def @param.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @temp_param.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @backup.variablerange(range)
      if(range[0]<range[1])
	DCL.uusidv(range[0], range[1])
      else
	DCL.uusidv(range[1], range[0])
      end
    end

    def @backup.variablerange
      DCL.uuqidv
    end

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
