module AdvancedDCL
  module Text
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("ifont", Fixnum,  "sgiset", "sgiget", 0, 0)
      @param.init("lcntl", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("small", Float, "sgrset", "sgrget", 0, 0)
      @param.init("shift", Float, "sgrset", "sgrget", 0, 0)
      @param.init("isup", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("isub", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("irst", Fixnum, "sgiset", "sgiget", 0, 0)
      @param.init("charsize", Float, "sgstxs", "sgqtxs", 1, 1)
      @param.init("charrot", Fixnum, "sgstxr", "sgqtxr", 1, 1)
      @param.init("charcent", Fixnum, "sgstxc", "sgqtxc", 1, 1)
      @param.init("charindex", Fixnum, "sgstxi", "sgqtxi", 1, 1)

      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init	

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def draw(ux, uy, chars, x=nil, y=nil, temp=nil)
      if(x.is_a?(Hash))
	temp = x
      elsif((x.is_a?(NArray))&&(x.rank==2))
	y = x.shape[1].to_f
	x = x.shape[0].to_f
	Basics.checkundef(x, y)
      elsif(Basics.typearray(x) && Basics.typearray(y))
	Basics.checkundef(x, y)
      elsif(x==nil&&y==nil)
	Basics.checkundef(1.0, 1.0)
      end
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.sgtxu(ux, uy, chars)
      @backup.sync
      @temp_param.clear
    end

    def vdraw(ux, uy, chars, x=nil, y=nil, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      #Fig.settrf

      DCL.sgtxv(ux, uy, chars)
      @backup.sync
      @temp_param.clear
    end

    #def udrawz(ux, uy, chars, size, rot, cent, index, temp=false)
     # @param.sync
     # @backup = @temp_param.set(temp, @param)
     # @temp_param.sync

     # Fig.settrf

     # DCL.sgtxzu(ux, uy, chars, size, rot, cent, index)
     # @backup.sync
     # @temp_param.clear
    #end

    #def vdrawz(ux, uy, chars, size, rot, cent, index, temp=false)
     # @param.sync
     # @backup = @temp_param.set(temp, @param)
     # @temp_param.sync

     # Fig.settrf

     # DCL.sgtxzv(ux, uy, chars, size, rot, cent, index)
     # @backup.sync
     # @temp_param.clear
    #end

    def spchar(number)
      DCL.csgi(number)
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :draw
    #module_function :udrawz
    module_function :vdraw
    #module_function :vdrawz
    module_function :spchar

    param_init

#----------------------------------------------------------

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }

  end
end
